=== debian/changelog ===
geonkick (2.10.2-0ubuntu4) noble; urgency=high

  * No change rebuild against libssl3t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 16:39:31 +0200

geonkick (2.10.2-0ubuntu3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 05:41:27 +0000

geonkick (2.10.2-0ubuntu2) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 17:58:15 +0000

geonkick (2.10.2-0ubuntu1) noble; urgency=medium

  * New upstream release 2.10.2
  * d/copyright:
    - Remove superfluous copyright
    - Add new license
  * d/control: add openssl build-dep
  * Remove no longer necessary patch

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Wed, 22 Nov 2023 10:10:56 -0800
