=== debian/watch ===
version=4

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/geonkick-$1\.tar\.gz/ \
  https://github.com/free-sm/geonkick/tags .*/v?(\d\S*)\.tar\.gz
